"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _core() {
  const data = require("@babel/core");

  _core = function _core() {
    return data;
  };

  return data;
}

function _helperPluginUtils() {
  const data = require("@babel/helper-plugin-utils");

  _helperPluginUtils = function _helperPluginUtils() {
    return data;
  };

  return data;
}

var _sourceMap = _interopRequireDefault(require("./sourceMap"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

const sourceMapProperty = 'sourceMap';

var _default = (0, _helperPluginUtils().declare)(api => {
  api.assertVersion(7);
  let readyImport = false;
  return {
    name: '@styils/babel-plugin',

    manipulateOptions(_, parserOpts) {
      const _ref = parserOpts,
            plugins = _ref.plugins;
      plugins.forEach((plugin, index) => {
        if (plugin === 'jsx') plugins.splice(index, 1);
      });
      plugins.forEach((plugin, index) => {
        const name = Array.isArray(plugin) ? plugin[0] : plugin;
        if (name === 'flow') plugins.splice(index, 1);
      });
      plugins.push('jsx', 'typescript', 'classProperties');
    },

    visitor: {
      Program: {
        enter(_, state) {
          var _state$opts$identifie;

          if (!state.opts.importPaths) {
            state.opts.importPaths = '@styils/react';
          }

          state.opts.identifier = _objectSpread({
            styled: 'styled',
            global: 'global'
          }, (_state$opts$identifie = state.opts.identifier) !== null && _state$opts$identifie !== void 0 ? _state$opts$identifie : {});
        }

      },

      ImportDeclaration(path, state) {
        const importPaths = state.opts.importPaths;

        if (importPaths) {
          const isImport = typeof importPaths === 'string' ? importPaths === path.node.source.value : importPaths.test(path.node.source.value);

          if (isImport) {
            readyImport = path.node.specifiers.some(childNode => {
              return state.opts.identifier[childNode.local.name];
            });
          }
        }
      },

      CallExpression(path, state) {
        var _state$file$opts$sour, _ref2, _state$file$opts$sour2;

        const sourceFileName = (_state$file$opts$sour = state.file.opts.sourceFileName) !== null && _state$file$opts$sour !== void 0 ? _state$file$opts$sour : state.opts.sourceFileName;
        const sourceRoot = (_ref2 = (_state$file$opts$sour2 = state.file.opts.sourceRoot) !== null && _state$file$opts$sour2 !== void 0 ? _state$file$opts$sour2 : state.opts.sourceRoot) !== null && _ref2 !== void 0 ? _ref2 : '';

        if (!sourceFileName) {
          throw new Error('To compile using api, you need to pass in `sourceFileName`');
        }

        if (readyImport && _core().types.isIdentifier(path.node.callee) && state.opts.identifier && state.opts.identifier[path.node.callee.name] && path.node.loc) {
          let parent = null;

          if (path.node.callee.name === state.opts.identifier.styled) {
            parent = path.findParent(parent => parent.isVariableDeclaration());
          } else if (path.node.callee.name === state.opts.identifier.global) {
            parent = path.findParent(parent => parent.isExpressionStatement());
          }

          if (parent) {
            const sourceMapNode = _core().types.logicalExpression('&&', _core().types.binaryExpression('!==', _core().types.memberExpression(_core().types.memberExpression(_core().types.identifier('process'), _core().types.identifier('env')), _core().types.identifier('NODE_ENV')), _core().types.stringLiteral('production')), _core().types.assignmentExpression('=', _core().types.memberExpression(_core().types.identifier(path.node.callee.name), _core().types.identifier(sourceMapProperty)), _core().types.stringLiteral((0, _sourceMap.default)(path.node.loc.start, {
              sourceFileName,
              sourceRoot,
              code: state.file.code
            }))));

            parent.insertBefore(sourceMapNode);
          }
        }
      }

    }
  };
});

exports.default = _default;