"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = addSourceMaps;

function _sourceMap() {
  const data = require("source-map");

  _sourceMap = function _sourceMap() {
    return data;
  };

  return data;
}

function _convertSourceMap() {
  const data = _interopRequireDefault(require("convert-source-map"));

  _convertSourceMap = function _convertSourceMap() {
    return data;
  };

  return data;
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function addSourceMaps(offset, state) {
  const code = state.code;
  const generator = new (_sourceMap().SourceMapGenerator)({
    file: state.sourceFileName,
    sourceRoot: state.sourceRoot
  });
  generator.setSourceContent(state.sourceFileName, code);
  generator.addMapping({
    generated: {
      line: 1,
      column: 0
    },
    source: state.sourceFileName,
    original: offset
  });
  return _convertSourceMap().default.fromObject(generator).toComment({
    multiline: true
  });
}