import { NodePath, types as t, type PluginPass } from '@babel/core';
export interface Options {
    identifier?: {
        styled?: string;
        global?: string;
    };
    importPaths?: string | RegExp;
    sourceFileName?: string;
    sourceRoot?: string;
}
export interface State extends PluginPass {
    opts: Options;
}
declare const _default: (api: object, options: Record<string, any> | null | undefined, dirname: string) => {
    name: string;
    manipulateOptions(_: any, parserOpts: any): void;
    visitor: {
        Program: {
            enter(this: PluginPass, _: NodePath<t.Program>, state: State): void;
        };
        ImportDeclaration(this: PluginPass, path: NodePath<t.ImportDeclaration>, state: State): void;
        CallExpression(this: PluginPass, path: NodePath<t.CallExpression>, state: State): void;
    };
};
export default _default;
